ARG UBI_IMAGE=registry.access.redhat.com/ubi8/ubi:8.5

FROM ${UBI_IMAGE}

ARG BUILD_DIR=/tmp/build
ARG LIBEDIT_VERSION=20170329-3.1
ARG DNF_OPTS

ENV LIBDIR ${LIBDIR:-"/usr/lib64"}
ENV INCLUDEDIR=/usr/include

RUN dnf ${DNF_OPTS} install -by --nodocs \
        autoconf cmake gcc gcc-c++ make patch perl \
        bzip2 libedit ncurses uuid libarchive \
        curl-devel libicu-devel libffi-devel libuuid-devel openssl-devel ncurses-devel pcre2-devel zlib-devel \
    && mkdir -p ${BUILD_DIR} \
    && cd ${BUILD_DIR} \
    # Adding libedit development headers from source.
    # Instructions are adapted from `libedit-3.1-23.20170329cvs.el8.src.rpm` spec.
    && curl --retry 6 https://thrysoee.dk/editline/libedit-${LIBEDIT_VERSION}.tar.gz | tar -xz \
    && cd libedit-${LIBEDIT_VERSION} \
    && ./configure --disable-static --disable-silent-rules --prefix=/usr --libdir=${LIBDIR} --includedir=${INCLUDEDIR} \
    && sed -i 's/lncurses/ltinfo/' src/Makefile \
    && sed -i -e 's/ -lncurses//' libedit.pc \
    && make -j $(nproc) \
    && cp -P src/.libs/libedit.so ${LIBDIR}/libedit.so \
    && cp libedit.pc ${LIBDIR}/pkgconfig/ \
    && cp src/histedit.h ${INCLUDEDIR}/ \
    && cp -R src/editline/ ${INCLUDEDIR}/

ADD scripts/ /

WORKDIR ${BUILD_DIR}
